module SimpleD3
  module LayoutHelper
    include ActionView::Helpers::TagHelper
    def simple_d3(placeholder, settings={})
      defaults = {
        :type    => :bar,
        :width    => 600,
        :height   => 250,
      }
      settings.reverse_merge!(defaults)
      graph = SimpleD3::Template.template(placeholder, settings).prepend(content_tag("div", "", {id: placeholder}))

      # Display without escaping html
      if defined?(raw)
        return raw(graph)
      else
        return graph
      end

    end

    def simple_d3_bar(placeholder, settings={})
      settings[:type] = "bar"
      settings[:width] = 600
      settings[:height] = 250
      settings[:colors] = ["#deebf7","#c6dbef","#9ecae1","#6baed6","#4292c6","#2171b5","#08519c","#08306b"]
      simple_d3(placeholder, settings)
    end

    def simple_d3_pie(placeholder, settings={})
      settings[:type] = "pie"
      settings[:width] = settings[:height] = 500
      simple_d3(placeholder, settings)
    end
  end
end

ActionView::Base.send :include, SimpleD3::LayoutHelper